{
    Copyright (C) 2010  Andrew Stawowczyk Long

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: info@dohm.com.au
}


unit coca_prev;

interface

uses
  Windows, Messages, SysUtils,  Graphics, Controls, Forms, hyiedefs,
  Dialogs, ieview, imageenview, AdvGlassButton, ExtCtrls, AdvPanel, StdCtrls,{$IFDEF D6}Variants, {$ENDIF D6}Classes,
  histogrambox, AdvSmoothLabel, AdvSmoothPanel, ComCtrls, imageenproc, 
  AdvEdit, imageenio, ieopensavedlg;

type
  TForm2 = class(TForm)
    image1: TImageEnView;
    AdvSmoothPanel9: TAdvSmoothPanel;
    AdvSmoothPanel1: TAdvSmoothPanel;
    CancelBtn: TAdvGlassButton;
    Bevel1: TBevel;
    hist1: THistogrambox;
    ImageEnProc1: TImageEnProc;
    R_edit: TAdvEdit;
    G_Edit: TAdvEdit;
    B_Edit: TAdvEdit;
    R_Label: TLabel;
    G_Label: TLabel;
    B_Label: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    CropBtn: TAdvGlassButton;
    SaveBtn: TAdvGlassButton;
    saveimg1: TSaveImageEnDialog;
    ImageEnIO1: TImageEnIO;
    procedure FormActivate(Sender: TObject);
    procedure image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure image1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure image1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CropBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    procedure WMLanguageChanged(var Message: TMessage);
    procedure LanguageChanged(Sender:TObject);
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  IsMoved: Boolean;
  zoom: double;
  start_x, start_y: integer;
  end_x, end_y: integer;
  new_image: string;

implementation

uses coca_main, LangConsts, plsLangMan;

{$R *.dfm}

procedure TForm2.CropBtnClick(Sender: TObject);
begin
 if (end_x <>0) AND (end_y<>0) then
   begin
     image1.Proc.CropSel;
     image1.Repaint;
     image1.DeSelect;
   end;
end;

procedure TForm2.CancelBtnClick(Sender: TObject);
begin
  close;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
 Form2.Caption:=Form2Title;
 screen.Cursor:=crHourglass;
 image1.Assign(Form1.Image1);
 hist1.Update;
 Label1.Caption:=Form1.ImgLabel.Caption;
 with image1.IO do
 if FileExists(target_file) then
 begin
   ParamsFromFile(target_file);
   Label2.Caption:= IntToStr(Params.Width)+' x '+IntToStr(Params.Height)+' pixels';
 end;
 screen.Cursor:=crDefault;
 start_x:= 0;
 start_y:= 0;
 end_x:= 0;
 end_y:= 0;
 new_image:='';
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
 LanguageChanged(self);
  Form2.Left:=10;
  Form2.Top:=60;
   LanguageManager.Refresh;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key=VK_ESCAPE then
   Close;
end;

procedure TForm2.image1Click(Sender: TObject);
var
  k: Word;
  ts: TShiftState;

begin
  FormKeyDown(Sender, k, ts);
end;

procedure TForm2.image1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key=VK_ESCAPE then
   Close;
end;

procedure TForm2.image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button = mbLeft then
 begin
    image1.MouseInteract:=[miSelect];
    start_x:= x;
    start_y:=y;
    Screen.Cursor:=crCross;
 end;
end;

procedure TForm2.image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  bitmapX,bitmapY:integer;
  color:TRGB;
begin
if isMoved then
  Image1.SetViewXY(x, y);

with Image1 do
 begin
   bitmapX:=imin(imax(0,XScr2Bmp(X)),IEBitmap.Width-1);
   bitmapY:=imin(imax(0,YScr2Bmp(Y)),IEBitmap.Height-1);
   color:=IEBitmap.Pixels[bitmapX,bitmapY];
   R_Edit.Text:= IntToStr(color.r);
   B_Edit.Text:= IntToStr(color.b);
   G_Edit.Text:=IntToStr(color.g);
  end;
end;

procedure TForm2.image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
   end_x:= x;
   end_y:=y;
   image1.Select(start_x, start_y, end_x, end_y);
  end;
  Screen.Cursor:=crDefault;
end;

procedure TForm2.WMLanguageChanged(var Message: TMessage);
begin
  LanguageChanged(Self);  // perform language changed event when language is changed by the user
  Message.Result := 0;
end;

procedure TForm2.LanguageChanged(Sender:TObject);
begin
 if not LanguageManager.LangVCL(Self) then
    MessageDlg(LanguageManager.LanguageName+' ('+LanguageManager.LanguageCode+
     '): ['+Self.Name+' ('+Self.ClassName+')] '+LanguageManager.LastError, mtWarning, [mbOK],0);
end;

procedure TForm2.SaveBtnClick(Sender: TObject);
begin
  if SaveImg1.Execute then
   begin
   With image1.IO do
    begin
     new_image:= saveimg1.FileName;
     SaveToFile(new_image, -1);
     Label1.Caption:= ExtractFileName(new_image);
     ParamsFromFile(new_image);
     Label2.Caption:= IntToStr(Params.Width)+' x '+IntToStr(Params.Height)+' pixels';
     hist1.Update;
    end;
   end;
end;

end.
